/*
    QGLView
    Ivan Pelipenko peri4ko@yandex.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef GLTEXTUREMANAGER_H
#define GLTEXTUREMANAGER_H

#include "glmaterial.h"

#include <QDir>
#include <QFileInfo>

class GLTextureManager: public GLTextureManagerBase {
public:
	GLTextureManager() { ; }
	~GLTextureManager() { deleteTextures(); }

	struct Animation {
		QString path;
		QVector<GLuint> bitmaps;
		GLuint bitmapID(const int frame) {
			if (frame < 0 || frame >= bitmaps.size()) return 0;
			return bitmaps[frame];
		}
	};

	void addTexture(const QString & path) { tex_pathes << path; }
	void addAnimation(const QString & dir, const QString & name) { anim_pathes << QPair<QString, QString>(dir, name); }
	bool loadTextures();
	void deleteTextures();
	void deleteTexture(const QString & name);
	Animation * findAnimation(const QString & name) {
		for (int i = 0; i < anim_ids.size(); ++i)
			if (anim_ids[i].first == name) return &(anim_ids[i].second);
		return 0;
	}

	QVector<QPair<QString, Animation>> anim_ids;

private:
	QStringList tex_pathes;
	QList<QPair<QString, QString>> anim_pathes;
};

#endif // GLTEXTUREMANAGER_H
